% Usage V = cheb2D (zs, ns)
%
% V(i,j) = cheb(zs(i,1),ns(j,1)) cheb(zs(i,2),ns(j,2))
%
% If zs is single precision, V will also be single precision
%
% $Id$
%

function V = cheb2D (zs, ns)
  assert(columns(zs), 2);
  assert(columns(ns), 2);
  #
  V = cheb(zs(:,1), ns(:,1)') .* cheb(zs(:,2), ns(:,2)');
  #
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
