% Usage [V1, V2] = cheb2D_deriv (zs, ns)
%
% V1(i,j) = cheb'(zs(i,1),ns(j,1)) cheb(zs(i,2),ns(j,2))
% V2(i,j) = cheb(zs(i,1),ns(j,1)) cheb'(zs(i,2),ns(j,2))
%
% If zs is single precision, [V1, V2] will also be single precision
%
% $Id$
%

function [V1, V2] = cheb2D_deriv (zs, ns)
  assert (columns(zs), 2);
  assert (columns(ns), 2);
  #
  V1 = cheb_deriv (zs(:,1), ns(:,1)') .* cheb (zs(:,2), ns(:,2)');
  V2 = cheb (zs(:,1), ns(:,1)') .* cheb_deriv (zs(:,2), ns(:,2)');
  #
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
