% Usage z = cheb_zeros (n)
%
% cheb(z(i),n) == 0
%

function z = cheb_zeros (n)
  if n <= 0
    z = zeros(0,1);
  else % n >= 1
    z = cos (([n-1:-1:0] + 0.5)*pi/n);
  endif
  if columns (z) > 1
    z = z';
  endif
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
