# Usage zs = fromEdge(x1, x2, xs)
#
# x1<->x2 --- line in R^2
# xs(i,:) --- i-th point inside x1<->x2
# zs(i) --- xs(i) affine linear mapped to [-1,1]
#
# $Id$
#

# z = 2*||x-x1||/||x2-x1|| - 1
function zs = fromEdge (x1, x2, xs)
  #
  m = rows(xs);
  assert(columns(xs), 2);
  if columns(x1) == 1
    x1 = x1';
  endif
  assert (columns(x1), 2);
  assert (rows(x1), 1);
  if columns(x2) == 1
    x2 = x2';
  endif
  assert (rows(x2), 1);
  assert (columns(x2), 2);
  zs = 2*norm(xs-ones(m,1)*x1, 2, "rows")/norm(x2-x1,2) - ones(m,1);
  zs = zs';
  #
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
