# Usage zs = fromQuad(XY, xs)
#
# xs(i,:) --- i-th point inside quadrilateral XY
# XY(i,:) --- i-th vertex of XY
# zs(i,:) --- xs(i,:) perspective mapped to [-1,1]x[-1,1]
#
# $Id$
#

function zs = fromQuad (XY, xs)
  #
  PQ = [-1 -1;
	 1 -1;
	 1  1;
	-1  1];
  #
  A = quad2quad(XY, PQ);
  #
  n = rows(xs);
  zs = [xs ones(n,1)] * A';
  zs = [zs(:,1) ./ zs(:,3), zs(:,2) ./ zs(:,3)];
  #
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
