## Usage: vertices = getVerticesOfQuad (Geom, q)
## 
## Return the 4 vertices of q-the quadrilateral in Geom
## Only the 4 points indices are returned
## 
## $Id$
## 

function vertices = getVerticesOfQuad (Geom, q)
  edges = Geom.Quads{q};
  ne = length (edges);	# no. of edges
  vertices = [];
  prev_line = -1;		# none
  for i = 1 : ne
    cur_line = Geom.Edges(abs(edges(i)), 1);
    if cur_line != prev_line	# new edge of quad
      ## Get head of edge
      if edges(i) > 0
	vert1 = Geom.Edges(edges(i), 2);
      else
	vert1 = Geom.Edges(abs(edges(i)), 3);
      endif
      ## 
      if (any (vertices == vert1))
	## print debug info
	patch = q
	edge_no = i
	cur_line = cur_line
	prev_line = prev_line
	edges = edges
	vertices = vertices
	vert1 = vert1
	error ("Huh?");		# how did it repeat?
      else
	vertices = [vertices vert1];	# add vertex
      endif
    endif
    prev_line = cur_line;
  endfor
  assert (length (vertices), 4);
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
