## Usage pxy = intersect (line1, line2)
## 
## line1 = [x11 y11;  point on line1
##          x21 y21]  another point on line1
## line2 = [x12 y12;  point on line2
##          x22 y22]  another point on line2
## 
## pxy = [px py] point on line1 and line2
## 

function pxy = intersect (line1, line2)
  A = [(line1(1,:) - line1(2,:))', (line2(2,:) - line2(1,:))'];
  b = (line2(2,:) - line1(2,:))';
  l = A \ b;
  pxy = l(1) * line1(1,:) + (1 - l(1)) * line1(2,:);
endfunction



# Local Variables: #
# mode: octave     #
# End:             #
