% Usage: mesh_norm_1d(xs)
%
% Assumes xs(i) are monotonic and -1 <= xs(i) <= 1
% Returns smallest and largest spacing among acos(xs)

function [hmin, hmax] = mesh_norm_1d (xs)
  n = max(size(xs));
  cs = acos(xs);
  hs = abs(cs(2:n) - cs(1:n-1));
  hmin = min(hs);
  hmax = max(hs);
endfunction

% Local Variables: %
% mode: octave     %
% End:             %
