# Usage a = msn_interp (s, m, a, b, xs, fs)
#
# s --- Sobolev weight
# m --- m * size(xs,1) is the order of the Chebyshev polynomial
# a --- left end-point of interval
# b --- right end-point interval
# xs --- Sample points
# fs --- Function at sample points
# a --- Chebyshev coefficients
#
# $Id: msn_interp.m,v 1.1 2012/06/01 00:06:50 shiv Exp shiv $
#

function a = msn_interp (s, m, a, b, xs, fs)
  zs = from_interval (a, b, xs);
  N = length (xs);
  M = round (m*N);
  V = cheb (zs, [0:1:M-1]);
  Dsi = diag ((1:M) .^ (-s));
  V = V * Dsi;
  [u, l, v] = rrulv (V);
  if rows (fs) != N
    fs = fs';
  endif
  a = Dsi * (v * (l \ (u' * fs)));
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
