# Usage gs = msn_reinterp2D (XY, xs, fs, s, N1, N2, ys)
#
# XY --- 4x2, rows are vertices of convex polynomial in anti-clockwise order
# xs --- Sample points (in XY hopefully)
# fs --- Function at sample points
# s --- Sobolev weight
# N = [N1 N2] --- Order of 2D Chebyshev polynomials
# ys --- points (in XY) where msn interpolant has to be evaluated
# gs --- values of msn interpolant at ys
#
# $Id$
#

function gs = msn_reinterp2D (XY, xs, fs, s, N, ys)
  [as, ord] = msn_interp2D (XY, xs, fs, s, N);
  gs = samp_cheb2D (XY, ys, ord, as);
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
