# Test msn_interp2D
# Also tests, persp_deriv and cheb2D_deriv.

s = single (6.5);

## Domain of interpolation: convex quadrilateral
XY = [-1 0;
      1 0;
      1 1;
      0 1];

n = 10*[2 3];			# grid size: [nx ny]
zs = cheb_zeros_2D_grid (n);
xs = toQuad (XY, zs);

function f = foo (xs)
  f = 1 ./ (1 + (xs(:,1) .^ 2) + (xs(:,2) .^ 2));
  # f = 1 + xs(:,1) - xs(:,2) - 2 * xs(:,1) .^ 2 + xs(:,1) .* xs(:,2) \
  #f = 1 + 2*xs(:,1) - xs(:,2) + (xs(:,2) .^ 2) + xs(:,1) .* xs(:,2) + \
  #    xs(:,1) .^ 3 + xs(:,1) .* (xs(:,2).^2);
  #     - 0.5 * xs(:,2) .^ 3 + (xs(:,1) .^ 2) .* (xs(:,2) .^ 2);
endfunction

function fp = foop (xs)
  fp = -2 * [(xs(:,1) ./ (1 + (xs(:,1) .^ 2) + (xs(:,2) .^ 2)) .^ 2), \
	     (xs(:,2) ./ (1 + (xs(:,1) .^ 2) + (xs(:,2) .^ 2)) .^ 2)];
  # m = rows(xs);
  # fp = [(2*ones(m,1)+xs(:,2)+3*xs(:,1).^2+xs(:,2).^2), \
#	(xs(:,1)-ones(m,1)+2*xs(:,2)+2*xs(:,1).*xs(:,2))];
endfunction

fs = foo (xs);
[as, ord] = msn_interp2D (XY, xs, fs, s, 2.5*n);

zs2 = cheb_zeros_2D_grid (2*n);
xs2 = toQuad (XY, zs2);
fs2 = samp_cheb2D (XY, xs2, ord, as);

fs3 = foo (xs2);
err = norm (fs2-fs3, Inf) / norm (fs3, Inf)

#figure(1);
#scatter3 (xs2(:,1), xs2(:,2), fs2);

## Standard square
PQ = [-1 -1;
       1 -1;
       1  1;
      -1  1];

[V1, V2] = cheb2D_deriv (zs2, ord);
A = quad2quad (XY, PQ);
m = rows (xs2);
fs2p = zeros (m, 2);
for i = 1 : m
  phip = persp_deriv (A, xs2(i,:));
  fs2p(i,1) = (phip(1,1) * V1(i,:) + phip(2,1) * V2(i,:)) * as;
  fs2p(i,2) = (phip(1,2) * V1(i,:) + phip(2,2) * V2(i,:)) * as;
endfor

fs3p = foop (xs2);

#figure(2);
#scatter3 (xs2(:,1), xs2(:,2), fs2p(:,2));
#figure(3);
#scatter3 (xs2(:,1), xs2(:,2), fs3p(:,2));

error21 = norm (fs2p(:,1)-fs3p(:,1), Inf) / \
    (norm (fs3, Inf) + norm (fs3p(:,1), Inf))
error22 = norm (fs2p(:,2)-fs3p(:,2), Inf) / \
    (norm (fs3, Inf) + norm (fs3p(:,2), Inf))



# Local Variables: #
# mode: octave     #
# End:             #
