## Test 1 of msnODE.m
## mu u'(x) + lambda u(x) = f(x)
## u(0)
## q = 1

## $Id: test_msnode_1.m,v 1.1 2012/03/14 04:23:01 shiv Exp shiv $

one = single(1);			# single(1) for single precision
realType = class(one);		# Single or double

s = 12*one;			# Sobolev parameter
Np = 5;			# Number of patches + 1
ys = cast([0:1/(Np-1):1], realType);		# The patches
assert(length(ys), Np);
ns = 20 * ones(1,Np-1); # Points per patch
M1 = 2.0*one;		# Order of MSN poly / mesh_norm

q = 1;

## A = [1]
function A = coeff1 (x)
  mu = cast(2, class(x));
  A = mu * cast([1], class(x));
endfunction

## B = [lambda]
function B = coeff0 (x)
  lambda = cast(1.0, class(x));
  B = lambda * cast([1], class(x));
endfunction

## u(x) = kron(exp(x*l),[1])
## l and x can be arrays
function u = soln (x, l)
  if columns(x) > 1
    my_x = x';
  else
    my_x = x;
  endif
  if rows(l) > 1
    my_l = l';
  else
    my_l = l;
  endif
  u = kron(exp (my_x * my_l), [1]);
endfunction

## u'(x) = kron(exp(x*l)*l,[1])
function up = solnp (x, l)
  if columns(x) > 1
    my_x = x';
  else
    my_x = x;
  endif
  if rows(l) > 1
    my_l = l';
  else
    my_l = l;
  endif
  up = kron(exp (my_x*my_l) * diag(my_l), [1]);
endfunction

CR = eye(1, realType);
CL = zeros(0, 1, realType);

global l
l = cast([-2.5, -1.0, 1.0, 3.6], realType);
nrhs = columns(l);
gL = CL*soln(ys(1), l);
gR = CR*soln(ys(Np), l);

function f = rhs(x)
  global l;
  m = length(x);
  k = length(l);
  f = zeros(m*1, k, class(x));
  for i=1:m
    f((i-1)*1+1:i*1,:) = coeff1(x(i))*solnp(x(i), l) + coeff0(x)*soln(x(i), l);
  endfor
endfunction

us1 = msnODE (q, @coeff1, @coeff0, @rhs, CL, CR, gL, gR, s, M1, ys, ns);
us2 = soln (ys(2:Np-1), l);
err = norm (us1-us2, Inf) / norm (us2, Inf)

# Local Variables: #
# mode: octave     #
# End:             #
