% Test of rrulv using single and double precision
%
% $Id$
%

M = 256; % no. of rows
N = 2*M; % no. of cols
K = 15; % no. of test vectors
s = 15.0; % Sobolev parameter

% Double precision set-up
zs = cheb_zeros(M);
V = cheb(zs, [0:N-1]);
Ds = sob_wts(s, N);
VDs = V * diag(1./Ds);
b = zeros(M, K);
for k=1:K
  b(:,k) = besselj(k-1, zs);
endfor
[u, l, vt] = rrulv(VDs);
cxt = vt * (l \ (u' * b));
cx = diag(1./Ds) * cxt;

# z = randn(M, K);
# xt = VDs' * z; % for min-norm solution
# b = VDs * xt;
# x = diag(1./Ds) * xt;

% Set-up and solve in single precision
zs1 = cheb_zeros(single(M));
V1 = cheb(zs1, [0:N-1]);
Ds1 = sob_wts(single(s), N);
VDs1 = V1 * diag(1./Ds1);
b1 = single(b);

# z1 = single(z);
# xt1 = VDs1' * z1; % for min-norm solution
# b1 = VDs1 * xt1;
# x1 = diag(1./Ds1) * xt1;


% Solve in single precision
cond = Ds(M)/Ds(1)
[u, l, vt] = rrulv(VDs1);
cxt1 = vt * (l \ (u' * b1));
class(cxt1)
cx1 = diag(1./Ds1) * cxt1;
class(cx1)
err1=norm(cx1-cx,Inf)/norm(cx,Inf)
#err2=norm(cx1-x,Inf)/norm(x,Inf)

% Local Variables: %
% mode: octave     %
% End:             %
