# Usage xs = toEdge (x1, x2, zs)
#
# x1<-->x2 --- line in R^2
# zs(i) ------ i-th point inside [-1,1]
# xs(i,:) ---- zs(i) affine linear mapped from [-1,1] to x1 <--> x2
#
# $Id$
#

# x = x1 + (z + 1) (x2 - x1) / 2
function xs = toEdge (x1, x2, zs)
  #
  if rows (zs) == 1
    zs = zs';
  endif
  #
  if rows (x1) == 2
    x1 = x1';
  endif
  #
  if rows (x2) == 2
    x2 = x2';
  endif
  #
  assert (columns (zs), 1);
  assert (rows (x1), 1);
  assert (rows (x2), 1);
  #
  m = rows (zs);
  #
  xs = ones (m, 1) * x1 + (zs + 1) * (x2 - x1) / 2;
  #
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
