# Usage xs = toQuad (XY, zs)
#
# zs(i,:) --- i-th point inside [-1,1]x[-1,1]
# xs(i,:) --- zs(i,:) perspective mapped to quadrilateral XY
# XY(i,:) --- i-th vertex of XY
#
# $Id$
#

function xs = toQuad (XY, zs)
  #
  assert (columns (zs), 2);
  #
  PQ = [-1 -1;
	 1 -1;
	 1  1;
	-1  1];
  #
  A = quad2quad (PQ, XY);
  #
  n = rows(zs);
  xs = [zs ones(n,1)] * A';
  xs = [xs(:,1) ./ xs(:,3), xs(:,2) ./ xs(:,3)];
  #
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
